<template>
  <section class="container">
    <reserve-explanation />
    <preference-definition />
    <contract-type />
    <accept-terms />
    <button
      class="btn btn-danger"
      @click.prevent.self="submit"
      :disabled="!preferenceIsSelected || !termsAccepted || submitting"
      >Reservar</button>

      <div class="footer">
      <home-footer />
    </div>
      
  </section>
</template>

<script>
import ReserveExplanation from '~/components/ReserveExplanation.vue'
import PreferenceDefinition from '~/components/PreferenceDefinition.vue'
import ContractType from '~/components/ContractType.vue'
import AcceptTerms from '~/components/AcceptTerms.vue'
import HomeFooter from '~/components/HomeFooter.vue'


export default {
  data() {
    return {
      submitting: false
    };
  },
  components: {
    ReserveExplanation,
    PreferenceDefinition,
    ContractType,
    AcceptTerms,
    HomeFooter
  },
  computed: {
    preferenceIsSelected() {
      return this.$store.getters.allPreferencesAreSelected;
    },
    termsAccepted() {
      return this.$store.getters.acceptTerms;
    }
  },
  methods: {
    submit() {
      this.submitting = true;
      const info = {};
      const local_request = {};
      local_request.contract_type = this.$store.getters.contractType;
      local_request.selectedPreferences = this.$store.getters.selectedPreferences;
      local_request.renew = false;
      local_request.user = this.$store.getters.loggedEmail;
      info.request = local_request;
      console.log(info);
      let ins = this;
      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/requests',
        data: info
      })
        .then( res => {
          ins.submitting = false;

          // clear form data
          ins.$store.commit('clearReserveInfo');

          // redirect
          ins.$router.push('/');
        });
    },
  }
}
</script>

<style scoped>
.btn {
  width: 100%;
}
</style>
